## zxing-cpp 1.0.8%2Bds2

=== debian/watch ===
version=4
opts="repack,compression=xz,repacksuffix=+ds, \
 dversionmangle=s/\+ds\d//, \
 repackdversionmangle=s/\+ds\d*$//, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%zxing-cpp_$1.orig.tar.gz%" \
 https://github.com/nu-book/zxing-cpp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
