=== debian/changelog ===
zxing-cpp (1.0.8+ds2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:29:24 +0100

zxing-cpp (1.0.8+ds2-2) unstable; urgency=high

  * Source-only upload to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Jan 2020 10:39:58 -0500

zxing-cpp (1.0.8+ds2-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <byang@debian.org>  Tue, 21 Jan 2020 16:51:37 -0500
