=== debian/changelog ===
zxing-cpp (1.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Aug 2020 16:08:00 -0400
