=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- cmake (>= 3.1.2),
+ debhelper-compat (= 13),
+ cmake (>= 3.10),
+ qtbase5-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://github.com/nu-book/zxing-cpp
