## zxing-cpp 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.10)
 
-project (ZXing VERSION "1.1.0" LANGUAGES CXX)
+project (ZXing VERSION "1.1.1" LANGUAGES CXX)
 
 option (BUILD_WRITERS "Build with writer support (encoders)" ON)
 option (BUILD_READERS "Build with reader support (decoders)" ON)
@@ -69,6 +69,9 @@
 if (BUILD_PYTHON_MODULE)
     add_subdirectory (wrappers/python)
 endif()
+if (WIN32)
+    add_subdirectory (wrappers/gdiplus)
+endif()
 
 set (CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/ZXing")
