=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required (VERSION 3.1.3)
-
-if (NOT DEFINED ENABLE_ENCODERS)
-    set (ENABLE_ENCODERS OFF)
-endif()
-
-if (NOT DEFINED ENABLE_DECODERS)
-    set (ENABLE_DECODERS ON)
+cmake_minimum_required (VERSION 3.10)
+
+if (NOT DEFINED BUILD_WRITERS)
+    set (BUILD_WRITERS OFF)
+endif()
+
+if (NOT DEFINED BUILD_READERS)
+    set (BUILD_READERS ON)
 endif()
 
 set (ZXING_CORE_DEFINES)
@@ -27,8 +27,6 @@
     set (ZXING_CORE_LOCAL_DEFINES ${ZXING_CORE_LOCAL_DEFINES}
         -Wall -Wextra -Wno-missing-braces)
 endif()
-
-set (CMAKE_CXX_STANDARD 14)
 
 
 ################# Source files
@@ -41,7 +39,11 @@
     src/BitHacks.h
     src/BitMatrix.h
     src/BitMatrix.cpp
+    src/BitMatrixCursor.h
+    src/BitMatrixIO.h
+    src/BitMatrixIO.cpp
     src/ByteArray.h
+    src/ByteMatrix.h
     src/CharacterSet.h
     src/CharacterSetECI.h
     src/CharacterSetECI.cpp
@@ -50,19 +52,26 @@
     src/GenericGF.cpp
     src/GenericGFPoly.h
     src/GenericGFPoly.cpp
+    src/GTIN.h
+    src/LogMatrix.h
+    src/Matrix.h
+    src/Pattern.h
+    src/Point.h
+    src/Quadrilateral.h
     src/TextUtfEncoding.h
     src/TextUtfEncoding.cpp
+    src/TritMatrix.h
     src/ZXBigInteger.h
     src/ZXBigInteger.cpp
     src/ZXConfig.h
-    src/ZXFilesystem.h
+    src/ZXFlags.h
     src/ZXNullable.h
     src/ZXNumeric.h
     src/ZXContainerAlgorithms.h
     src/ZXStrConvWorkaround.h
     src/ZXTestSupport.h
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (COMMON_FILES ${COMMON_FILES}
         src/BinaryBitmap.h
         src/BitSource.h
@@ -104,7 +113,7 @@
         src/WhiteRectDetector.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (COMMON_FILES ${COMMON_FILES}
         src/ByteMatrix.h
         src/ReedSolomonEncoder.h
@@ -119,7 +128,7 @@
 
 set (AZTEC_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (AZTEC_FILES ${AZTEC_FILES}
         src/aztec/AZDecoder.h
         src/aztec/AZDecoder.cpp
@@ -130,7 +139,7 @@
         src/aztec/AZReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (AZTEC_FILES ${AZTEC_FILES}
         src/aztec/AZEncodingState.h
         src/aztec/AZEncoder.h
@@ -147,7 +156,7 @@
 
 set (DATAMATRIX_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
         src/datamatrix/DMBitMatrixParser.h
         src/datamatrix/DMBitMatrixParser.cpp
@@ -164,7 +173,7 @@
         src/datamatrix/DMReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
         src/datamatrix/DMECEncoder.h
         src/datamatrix/DMECEncoder.cpp
@@ -184,7 +193,7 @@
 
 set (MAXICODE_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (MAXICODE_FILES ${MAXICODE_FILES}
         src/maxicode/MCBitMatrixParser.h
         src/maxicode/MCBitMatrixParser.cpp
@@ -202,7 +211,7 @@
     src/oned/ODCode128Patterns.h
     src/oned/ODCode128Patterns.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (ONED_FILES ${ONED_FILES}
         src/oned/ODCodabarReader.h
         src/oned/ODCodabarReader.cpp
@@ -240,7 +249,7 @@
         src/oned/ODUPCEReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (ONED_FILES ${ONED_FILES}
         src/oned/ODCodabarWriter.h
         src/oned/ODCodabarWriter.cpp
@@ -268,7 +277,7 @@
 
 set (ONED_RSS_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (ONED_RSS_FILES ${ONED_RSS_FILES}
         src/oned/rss/ODRSSDataCharacter.h
         src/oned/rss/ODRSSExpandedBinaryDecoder.h
@@ -289,7 +298,7 @@
 
 set (PDF417_FILES
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFBarcodeMetadata.h
         src/pdf417/PDFBarcodeValue.h
@@ -318,7 +327,7 @@
         src/pdf417/PDFScanningDecoder.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
         src/pdf417/PDFEncoder.h
@@ -339,7 +348,7 @@
     src/qrcode/QRVersion.h
     src/qrcode/QRVersion.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (QRCODE_FILES ${QRCODE_FILES}
         src/qrcode/QRAlignmentPattern.h
         src/qrcode/QRAlignmentPattern.cpp
@@ -368,7 +377,7 @@
         src/qrcode/QRReader.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (QRCODE_FILES ${QRCODE_FILES}
         src/qrcode/QREncoder.h
         src/qrcode/QREncoder.cpp
@@ -389,7 +398,7 @@
     src/textcodec/KRHangulMapping.h
     src/textcodec/KRHangulMapping.cpp
 )
-if (ENABLE_DECODERS)
+if (BUILD_READERS)
     set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
         src/textcodec/Big5TextDecoder.h
         src/textcodec/Big5TextDecoder.cpp
@@ -401,7 +410,7 @@
         src/textcodec/KRTextDecoder.cpp
     )
 endif()
-if (ENABLE_ENCODERS)
+if (BUILD_WRITERS)
     set (TEXT_CODEC_FILES ${TEXT_CODEC_FILES}
         src/textcodec/Big5TextEncoder.h
         src/textcodec/Big5TextEncoder.cpp
@@ -414,6 +423,3 @@
     )
 endif()
 
-source_group (Sources FILES ${COMMON_FILES})
-source_group (Sources\\aztec FILES ${AZTEC_FILES})
-source_group (Sources\\datamatrix FILES ${DATAMATRIX_FILES})
