=== wrappers/gdiplus/CMakeLists.txt ===
--- 
+++ 
@@ -16,18 +16,19 @@
         set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
         set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
     endif()
+
+    if (NOT DEFINED BUILD_WRITERS)
+        set (BUILD_WRITERS OFF)
+    endif()
+
+    if (NOT DEFINED BUILD_READERS)
+        set (BUILD_READERS ON)
+    endif()
+
+    add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXingCore)
+    
 endif()
 
-if (NOT DEFINED BUILD_WRITERS)
-    set (BUILD_WRITERS OFF)
-endif()
-
-if (NOT DEFINED BUILD_READERS)
-    set (BUILD_READERS ON)
-endif()
-
-add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)
-    
 set (LOCAL_COMMON_FILES
     GdiplusInit.h
     GdiplusInit.cpp
