=== debian/changelog ===
zxing-cpp (1.1.1-2) unstable; urgency=medium

  * debian/control: Update build-dependency and package description
    according to upstream recommendation.
  * Rebuild before Debian 11 release.

 -- Boyuan Yang <byang@debian.org>  Sat, 19 Dec 2020 19:31:32 -0500

zxing-cpp (1.1.1-1) unstable; urgency=medium

  * New upstream release. 

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Sep 2020 18:53:42 -0400
