=== debian/watch ===
version=4
opts=" \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%zxing-cpp_$1.orig.tar.gz%" \
 https://github.com/nu-book/zxing-cpp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
